#ifndef RWLOCK_H
#define RWLOCK_H

#include <condition_variable>
#include <mutex>
#include <thread>

class RWlock {
    RWlock();
    RWlock( const RWlock & ) = delete;
    RWlock( RWlock && ) = delete;
    RWlock &operator=( RWlock ) = delete;

    void readerLock();
    void readerUnlock();
    void writerLock();
    void writerUnlock();
};


class ReadLock {
    RWlock &_lock;
public:
    ReadLock( RWlock &l ) : _lock( l ) {}
    ReadLock( const ReadLock & ) = delete;
    ReadLock( ReadLock && ) = delete;
    ReadLock operator=( ReadLock ) = delete;

    void lock() {
        _lock.readerLock();
    }
    void unlock() {
        _lock.readerUnlock();
    }
};

class WriteLock {
    RWlock &_lock;
public:
    WriteLock( RWlock &l ) : _lock( l ) {}
    WriteLock( const WriteLock & ) = delete;
    WriteLock( WriteLock && ) = delete;
    WriteLock operator=( WriteLock ) = delete;

    void lock() {
        _lock.writerLock();
    }
    void unlock() {
        _lock.writerUnlock();
    }
};


#endif